maxIterations@100000
local randomSeed,random=Core.randomSeed,Core.random
randomSeed(1,1)

local sprite1,sprite2=Bitmap.new(Texture.new("chel3.png",true)),Bitmap.new(Texture.new("chel3.png",true))
sprite1:setPosition(50,50); sprite2:setPosition(200,500)
stage:addChild(sprite1); stage:addChild(sprite2)

--[[COLLISION:
function testCollision1()
	local trigger=false
	for i=1,maxIterations do
		if sprite1:getY() + sprite1:getHeight()/3 < sprite2:getY() then trigger=false end
        if sprite1:getY() > sprite2:getY() + sprite2:getHeight() then trigger=false end
        if sprite1:getX() > sprite2:getX() + sprite2:getWidth() then trigger=false end
        if sprite1:getX() + sprite1:getWidth()/3 < sprite2:getX() then trigger=false end
        trigger=true
	end
end

function testCollision2()
	local trigger=false
	for i=1,maxIterations do
		local x,y,w,h = sprite1:getBounds(stage)
		local x2,y2,w2,h2 = sprite2:getBounds(stage)
		trigger = not ((y+h < y2) or (y > y2+h2) or (x > x2+w2) or (x+w < x2))
	end
end

--print(testCollision1(),testCollision2())
Core.profilerReset()
Core.profilerStart()
for loop=1,10 do
	testCollision1()
	testCollision2()
end
Core.profilerStop()
 
-- print the results of the profiler
result=Core.profilerReport()
print("Number of tests:",maxIterations*10)
 
for k,v in pairs(result) do
	local found=false
 
	for k2,v2 in pairs(v) do
		if found and k2=="time" then print(v1,v2) end
		if k2=="name" and string.sub(v2,1,4)=="test" then v1=v2 found=true end
	end
end
]]


--[[***Get angle:
function getAngle1(ptA, ptB)
	local angle = math.deg(math.atan2(ptA:getY() - ptB:getY(), ptA:getX() - ptA:getX()))
	return angle
end
--angle = math.deg(math.atan2(player.y – object.y, player.x-object.x))

--Get angle alternative:
function getAngle2(ptA, ptB)
	local angle = math.deg(math.atan2(ptA:getY() - ptB:getY(), ptA:getX() - ptB:getX()))
	angle = angle + 90
	return angle
end

print(getAngle1(sprite1,sprite2))
print(getAngle2(sprite1,sprite2))
]]




--[[VANILLA Get distance:
function getDistance1(obj1, obj2)
	local dx, dy = math.abs(obj1:getX() - obj2:getX()), math.abs(obj1:getY() - obj2:getY())
	local distance = math.sqrt(dx*dx + dy*dy)
	return distance
end

function getDistance2(objA, objB)
  return math.sqrt((objA:getX() - objB:getX())^2 + (objA:getY() - objB:getY())^2)
end

function getDistance3(point1, point2)
	local xfactor = point2:getX()-point1:getX() ; local yfactor = point2:getY()-point1:getY()
	local distanceBetween = math.sqrt((xfactor*xfactor) + (yfactor*yfactor))
	return distanceBetween
end

print(getDistance1(sprite1,sprite2))
print(getDistance2(sprite1,sprite2))
print(getDistance3(sprite1,sprite2))]]

--Get distance V2:
function testDistance1()
	local distanceNum=0; randomSeed(1,1)
	
	for i=1,maxIterations do
		local x1,x2,y1,y2=random(0,320),random(0,320),random(0,480),random(0,480)
		local dx, dy = math.abs(x1 - x2), math.abs(y1 - y2)
		distanceNum = math.sqrt(dx*dx + dy*dy)
	end
end

function testDistance2()
	local distanceNum=0; randomSeed(1,1)
	
	for i=1,maxIterations do
		local x1,x2,y1,y2=random(0,320),random(0,320),random(0,480),random(0,480)
		distanceNum = math.sqrt((x1 - x2)^2 + (y1 - y2)^2)
	end
end

function testDistance3()
	local distanceNum=0; randomSeed(1,1)
	
	for i=1,maxIterations do
		local x1,x2,y1,y2=random(0,320),random(0,320),random(0,480),random(0,480)
		local xfactor = x2-x1 ; local yfactor = y2-y1
		distanceNum = math.sqrt((xfactor*xfactor) + (yfactor*yfactor))
	end
end

function testDistance4()
	local distanceNum=0; randomSeed(1,1)
	
	for i=1,maxIterations do
		local x2,y2=random(0,320),random(0,480)
		x2-=random(0,320); y2-=random(0,480)
		distanceNum = math.sqrt(x2*x2+y2*y2)
	end
end

function testDistance5()
	local distanceNum=0; randomSeed(1,1)
	local trigger1=true
	
	for i=1,maxIterations do
	if trigger1 then
		local x1,x2,y1,y2=random(0,320),random(0,320),random(0,480),random(0,480)
		local xfactor = x2-x1 ; local yfactor = y2-y1
		distanceNum = math.sqrt((xfactor*xfactor) + (yfactor*yfactor))
	end
	end
end

function testDistance6()
	local distanceNum=0; randomSeed(1,1)
	local trigger1,trigger2,trigger3=false,false,true
	
	for i=1,maxIterations do
	if trigger1 and not trigger2 and trigger3 then
		local x1,x2,y1,y2=random(0,320),random(0,320),random(0,480),random(0,480)
		local xfactor = x2-x1 ; local yfactor = y2-y1
		distanceNum = math.sqrt((xfactor*xfactor) + (yfactor*yfactor))
	end
	end
end

--[[
MATHSQRT @ (|
	local enteredNum=...
	return math.sqrt(enteredNum[1])
|)
--print(MATHSQRT(100)) --it works, prints "10"

function testDistance4()
	local distanceNum=0; randomSeed(1,1)
	
	for i=1,maxIterations do
		local x1,x2,y1,y2=random(0,320),random(0,320),random(0,480),random(0,480)
		local xfactor = x2-x1 ; local yfactor = y2-y1
		distanceNum = MATHSQRT((xfactor*xfactor) + (yfactor*yfactor))
	end
end
]]

--[[testDistance5 @ (|
	local distanceNum=0;
	
	--for i=1,maxIterations do
		local x1,x2,y1,y2=math.random(0,320),math.random(0,320),math.random(0,480),math.random(0,480); print(x1,x2,y1,y2)
		local xfactor = x2-x1 ; local yfactor = y2-y1
		distanceNum = ((xfactor*xfactor) + (yfactor*yfactor))*((xfactor*xfactor) + (yfactor*yfactor))
		return distanceNum
	--end
|)]]

--print(MATHSQRT(10000))

--Let's test 4 distance functions:
Core.profilerReset()
Core.profilerStart()
for loop=1,10 do
	--testDistance1()
	--testDistance2()
	testDistance3()
	testDistance4()
	--testDistance5()
	--testDistance6()
end
Core.profilerStop()

-- print the results of the profiler
result=Core.profilerReport()
print("Number of tests:",maxIterations*10)

for k,v in pairs(result) do
	local found=false
	
	for k2,v2 in pairs(v) do
		if found and k2=="time" then print(v1,v2) end
		if k2=="name" and string.sub(v2,1,4)=="test" then v1=v2 found=true end
	end
end





--print(Core.random(0,320),Core.random(0,320),Core.random(0,480),Core.random(0,480))




--***OLD BENCH
--[[
function keepInRange1()
	randomSeed(1,1); local tempStorage,tempNum=0,5
	for i=1,maxIterations do
		tempNum=random(0,-100,100)
		tempStorage=math.min(math.max(1, tempNum), 10)
	end
end


function keepInRange2()
	randomSeed(1,1); local tempStorage,tempNum=0,5
	for i=1,maxIterations do
		tempNum=random(0,-100,100)
		if tempNum < 1 then tempStorage=1
		elseif tempNum > 10 then tempStorage=10
		else tempStorage=tempNum end
	end
end


function keepInRange3()
	randomSeed(1,1); local tempStorage,tempNum=0,5
	for i=1,maxIterations do
		tempNum=random(0,-100,100)
		tempStorage=10><(1<>tempNum)
	end
end

function keepInRange4()
	randomSeed(1,1); local tempStorage,tempNum=0,5
	local mathMin,mathMax=math.min,math.max
	for i=1,maxIterations do
		tempNum=random(0,-100,100)
		tempStorage=mathMin(mathMax(1, tempNum), 10)
	end
end

function keepInRange5()
	randomSeed(1,1); local tempStorage,tempNum=0,5
	for i=1,maxIterations do
		local mathMin,mathMax=math.min,math.max
		tempNum=random(0,-100,100)
		tempStorage=mathMin(mathMax(1, tempNum), 10)
	end
end


Core.profilerReset()
Core.profilerStart()
for loop=1,10 do
	keepInRange1()
	keepInRange2()
	keepInRange3()
	keepInRange4()
	keepInRange5()
end
Core.profilerStop()

-- print the results of the profiler
result=Core.profilerReport()
print("Number of tests:",maxIterations*10)

for k,v in pairs(result) do
	local found=false
	
	for k2,v2 in pairs(v) do
		if found and k2=="time" then print(v1,v2) end
		if k2=="name" and string.sub(v2,1,4)=="keep" then v1=v2 found=true end
	end
end
]]