maxIterations@100000
local randomSeed,random=Core.randomSeed,Core.random
randomSeed(1,1)

function testDistance3()
	local distanceNum=0; randomSeed(1,1)
	
	for i=1,maxIterations do
		local x1,x2,y1,y2=random(0,320),random(0,320),random(0,480),random(0,480)
		local xfactor = x2-x1 ; local yfactor = y2-y1
		distanceNum = math.sqrt((xfactor*xfactor) + (yfactor*yfactor))
	end
end

function testDistance4()
	local distanceNum=0; randomSeed(1,1)
	
	for i=1,maxIterations do
		local x2,y2=random(0,320),random(0,480)
		x2-=random(0,320); y2-=random(0,480)
		distanceNum = math.sqrt(x2*x2+y2*y2)
	end
end

function testDistance5()
	local distanceNum=0; randomSeed(1,1)
 
	for i=1,maxIterations do
		local x1,x2,y1,y2=random(0,320),random(0,320),random(0,480),random(0,480)
		x2-=x1; y2-=y1
		distanceNum = math.sqrt(x2*x2+y2*y2)
	end
end

function testDistance6()
	local distanceNum=0; randomSeed(1,1)
 
	for i=1,maxIterations do
		local x2,y2=random(0,320),random(0,480)
		x2-=random(0,320); y2-=random(0,480)
		distanceNum = math.sqrt(x2*x2+y2*y2)
	end
end


--Let's test:
Core.profilerReset()
Core.profilerStart()
for loop=1,10 do
	testDistance3()
	testDistance4()
	testDistance5()
	testDistance6()
end
Core.profilerStop()

-- print the results of the profiler:
result=Core.profilerReport()
print("Number of tests:",maxIterations*10)

for k,v in pairs(result) do
	local found=false
	
	for k2,v2 in pairs(v) do
		if found and k2=="time" then print(v1,v2) end
		if k2=="name" and string.sub(v2,1,4)=="test" then v1=v2 found=true end
	end
end